# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class Instance(pulumi.CustomResource):
    arn: pulumi.Output[str]
    """
    The ARN of the Lightsail instance (matches `id`).
    * `availability_zone`
    * `blueprint_id`
    * `bundle_id`
    * `key_pair_name`
    * `user_data`
    """
    availability_zone: pulumi.Output[str]
    """
    The Availability Zone in which to create your
    instance (see list below)
    """
    blueprint_id: pulumi.Output[str]
    """
    The ID for a virtual private server image
    (see list below)
    """
    bundle_id: pulumi.Output[str]
    """
    The bundle of specification information (see list below)
    """
    cpu_count: pulumi.Output[int]
    created_at: pulumi.Output[str]
    ipv6_address: pulumi.Output[str]
    is_static_ip: pulumi.Output[bool]
    key_pair_name: pulumi.Output[str]
    """
    The name of your key pair. Created in the
    Lightsail console (cannot use `aws_key_pair` at this time)
    """
    name: pulumi.Output[str]
    """
    The name of the Lightsail Instance
    """
    private_ip_address: pulumi.Output[str]
    public_ip_address: pulumi.Output[str]
    ram_size: pulumi.Output[int]
    user_data: pulumi.Output[str]
    """
    launch script to configure server with additional user data
    """
    username: pulumi.Output[str]
    def __init__(__self__, __name__, __opts__=None, availability_zone=None, blueprint_id=None, bundle_id=None, key_pair_name=None, name=None, user_data=None):
        """
        Provides a Lightsail Instance. Amazon Lightsail is a service to provide easy virtual private servers
        with custom software already setup. See [What is Amazon Lightsail?](https://lightsail.aws.amazon.com/ls/docs/getting-started/article/what-is-amazon-lightsail)
        for more information.
        
        > **Note:** Lightsail is currently only supported in a limited number of AWS Regions, please see ["Regions and Availability Zones in Amazon Lightsail"](https://lightsail.aws.amazon.com/ls/docs/overview/article/understanding-regions-and-availability-zones-in-amazon-lightsail) for more details
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] availability_zone: The Availability Zone in which to create your
               instance (see list below)
        :param pulumi.Input[str] blueprint_id: The ID for a virtual private server image
               (see list below)
        :param pulumi.Input[str] bundle_id: The bundle of specification information (see list below)
        :param pulumi.Input[str] key_pair_name: The name of your key pair. Created in the
               Lightsail console (cannot use `aws_key_pair` at this time)
        :param pulumi.Input[str] name: The name of the Lightsail Instance
        :param pulumi.Input[str] user_data: launch script to configure server with additional user data
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not availability_zone:
            raise TypeError('Missing required property availability_zone')
        __props__['availability_zone'] = availability_zone

        if not blueprint_id:
            raise TypeError('Missing required property blueprint_id')
        __props__['blueprint_id'] = blueprint_id

        if not bundle_id:
            raise TypeError('Missing required property bundle_id')
        __props__['bundle_id'] = bundle_id

        __props__['key_pair_name'] = key_pair_name

        __props__['name'] = name

        __props__['user_data'] = user_data

        __props__['arn'] = None
        __props__['cpu_count'] = None
        __props__['created_at'] = None
        __props__['ipv6_address'] = None
        __props__['is_static_ip'] = None
        __props__['private_ip_address'] = None
        __props__['public_ip_address'] = None
        __props__['ram_size'] = None
        __props__['username'] = None

        super(Instance, __self__).__init__(
            'aws:lightsail/instance:Instance',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

